#include <conio.h>
#include "g_vstup.h"
#include "g_graph.h"

/*** barvy: ***/

#define B_B_INFO   0
#define B_T_INFO  11
#define B_B_MENU   0
#define B_T_MENU  11
#define B_B_MN_A   3
#define B_T_MN_A   0
#define B_B_DATA   0
#define B_T_DATA  14

/*** urceni pozice menu na obrazovce: ***/

#define MENU_X1   29
#define MENU_X2   49
#define MENU_DX   21
#define MENU_Y1   11

/*** klavesy (pouzito ve funkci smycka): ***/

#define klUp     72
#define klDown   80
#define klEnter  13
#define klEsc    27

/*** staticke promenne (pouzivane pouze v tomto modulu - souboru): ***/

// promenna fce obsahuje udaje o funkci, ktera ma byt vykreslena
static TFce fce = { 0.0, 0.0, 0.0, 1.0, -5.0, 5.0, -5.0, 5.0, 14 };
static char mnText[9][19] = { " Koeficient a",  // text pro menu
                              " Koeficient b",
                              " Koeficient c",
                              " Koeficient d",
                              " Interval na ose x",
                              " Interval na ose y",
                              " Barva",
                              " Vykreslit",
                              " Konec programu" };

/*** staticke funkce (viditelne pouze v tomto modulu): ***/

// funkce provede prikaz zvoleny v menu klavesou ENTER:
static void provest(int *prikaz);
// funkce vykresli jeden radek menu v zadanych barvach pozadi a textu:
static void MenuRad(int pozice, int bBack, int bText);
// funkce provede zmenu aktivniho radku menu (puvodni odaktivni a novy zaktivni):
static void MenuZmena(int *pozice, int nova);
// funkce vypise zadany text (upozorneni) a nacte ciselnou hodnotu do prom. cislo:
static void ZadejCislo(char *text, float *cislo);
// funkce vykresli paletu dovolenych barev a nacte cislo znamenajici jednu barvu:
static void ZadejBarvu(void);
// funkce vypise udaje nactene v promenne fce:
static void VypisUdaje(void);
// funkce odstrani blikajici textovy kurzor z obrazovky:
static void SchovejKurzor(void);

/* Znaky, ktere nejsou na klavesnici, vypiseme takto:
   drzime levy ALT a na ciselne klavesnici (po prave ruce) vypiseme trojici
   cislic, pak ALT pustime a znak se objevi.
170         tzn. 170, 171, 172, ..., 179
180              180, 181, 182, ..., 189 atd.
190 
200 
210 u
220 
230 
240 
250 
*/

/*** definice funkci: ***/

void init(void)
{
  int i;

  VypisUdaje();              // vypsany implicitni udaje o funkci

  window(1,MENU_Y1-1,80,23);
  textbackground(B_B_MENU);
  clrscr();
  textcolor(B_B_MENU);
  putch('');             /* absolutni pozice [1, MENU_Y1-1] */
                          // na toto misto se bude schovavat kurzor
  textcolor(B_T_MENU);
  gotoxy(MENU_X1, 2);
  putch('');             // taky mozno napsat putch(201)
  for (i = 2; i < MENU_DX; i++) putch('');
  putch('');
  for (i = 1; i <= 9; i++) {
    gotoxy(MENU_X1, 2+i); putch('');
    gotoxy(MENU_X2, 2+i); putch('');
  }
  gotoxy(MENU_X1, 12); putch('');
  for (i = 2; i < MENU_DX; i++) putch('');
  putch('');
  // vypsani textu do menu, prvni radek aktivni:
  MenuRad(1, B_B_MN_A, B_T_MN_A);
  for (i = 2; i <= 9; i++)
    MenuRad(i, B_B_MENU, B_T_MENU);

  window(1,MENU_Y1+12,80,25);
  textbackground(B_B_DATA);
  textcolor(B_T_DATA);
  clrscr();
  SchovejKurzor();
}

void done(void)
{
  window(1,1,80,25);
  textbackground(BLACK);
  textcolor(LIGHTGRAY);
  clrscr();
}

void smycka(void)
{
  int zn, vybrano, pom, konec;

  vybrano = 1;
  konec = 0;
  do {
    zn = getch();
    if (zn == 0) {
      zn = getch();
      if (zn == klUp) {
        pom = (vybrano > 1)? (vybrano-1) : (9); // ternarni operator  ?:
        MenuZmena(&vybrano, pom); // musi byt &, protoze ve funkci chceme menit hodnotu teto promenne
      } else if (zn == klDown) {
        pom = (vybrano < 9)? (vybrano+1) : (1);
        MenuZmena(&vybrano, pom);
      }
    } else if (zn == klEnter) {
      if(vybrano == 9) konec = 1; // na pozici 9 je v menu text "Konec programu"
      else provest(&vybrano);     // jinak se provede urceny prikaz
    } else if (zn == klEsc) konec = 1;
  } while (!konec);               // provadime, dokud je konec == 0
}

void provest(int *prikaz)
{
  float pom;
  // v prikazech jsou pouzity dereference &, protoze parametrem funkce je adresa
  // (ve funkci menime hodnotu promenne)
  switch(*prikaz) {
    case 1: ZadejCislo("Zadej koeficient a = ", &fce.a); break;
    case 2: ZadejCislo("Zadej koeficient b = ", &fce.b); break;
    case 3: ZadejCislo("Zadej koeficient c = ", &fce.c); break;
    case 4: ZadejCislo("Zadej koeficient d = ", &fce.d); break;
    case 5: ZadejCislo("Zadej doln mez intervalu na ose x: min_x = ", &fce.x1);
            ZadejCislo("Zadej horn mez intervalu na ose x: max_x = ", &fce.x2);
            if (fce.x1 > fce.x2) {
              pom = fce.x1;
              fce.x1 = fce.x2;
              fce.x2 = pom;
              VypisUdaje();
            }
            break;
    case 6: ZadejCislo("Zadej doln mez intervalu na ose y: min_y = ", &fce.y1);
            ZadejCislo("Zadej horn mez intervalu na ose y: max_y = ", &fce.y2);
            if (fce.y1 > fce.y2) {
              pom = fce.y1;
              fce.y1 = fce.y2;
              fce.y2 = pom;
              VypisUdaje();
            }
            break;
    case 7: ZadejBarvu(); break;
    case 8: vykresli(fce);
            *prikaz = 1;
            init();
            break;
    default: break;
  }
  SchovejKurzor();
}

void MenuRad(int pozice, int bBack, int bText)
{
  window(MENU_X1+1,MENU_Y1+pozice, MENU_X2-1, MENU_Y1+pozice);
  textbackground(bBack);
  textcolor(bText);
  cprintf("%s", mnText[pozice-1]);
  clreol(); // vyplni prostor az do konce radku ve window
}

void MenuZmena(int *pozice, int nova)
{
  MenuRad(*pozice, B_B_MENU, B_T_MENU);
  MenuRad(nova, B_B_MN_A, B_T_MN_A);
  *pozice = nova;
  SchovejKurzor();
}

void ZadejCislo(char *text, float *cislo)
{
  float pom;
  int zn;

  window(2,24,79,25);
  textbackground(B_B_DATA);
  textcolor(B_T_DATA);
  cprintf("%s", text);
  cscanf("%f", &pom);
  zn = getch();// funkce cscanf ma problemy se zaverecnym ENTER, proto je toto nutne
  clrscr();
  if (zn == klEnter) {
    *cislo = pom;
    VypisUdaje();
  }
}

void ZadejBarvu(void)
{
  int i, zn;

  window(2,24,79,25);
  textbackground(BLACK);
  cputs("    ");
  for (i = 1; i < 16; i++) {
    textcolor(i);
    cprintf(" %d",i);
  }
  textcolor(B_T_DATA);
  cputs("\r\nZadej slo z intervalu 1..15 urujc barvu: ");
  cscanf("%d",&i);
  zn = getch();
  clrscr();
  if ((i > 0)&&(i < 16)&&(zn == klEnter)) {
    fce.barva = i;
    VypisUdaje();
  }
}

void VypisUdaje(void)
{
  int i;

  window(1,1,80,9);
  textbackground(B_B_INFO);
  textcolor(B_T_INFO);
  clrscr();
  cputs("daje:\r\n\n");
  cprintf(" Polynom a*x^3 + b*x^2 + c*x + d, kde  a = %4.3f\r\n",fce.a);
  cprintf("                                       b = %4.3f\r\n",fce.b);
  cprintf("                                       c = %4.3f\r\n",fce.c);
  cprintf("                                       d = %4.3f\r\n",fce.d);
  cprintf(" se vykresl na intervalu  na ose x <%4.3f,%4.3f>\r\n",fce.x1,fce.x2);
  cprintf("                           na ose y <%4.3f,%4.3f>\r\n",fce.y1,fce.y2);
  cprintf(" v barv ");
  window(12,9,80,9);
  textcolor(fce.barva);
  textbackground(0);
  for(i = 1; i < 68; i++) putch('');    //'');
}

void SchovejKurzor(void)
{
  window(1,MENU_Y1-1,1,MENU_Y1);
}
